#pragma once
#include <vector>
#include <JGL/types/Texture.h>

namespace Engine {
    class InstancedTexture;
    class InstancedSprite;
}

class Engine::InstancedTexture {
protected:
    JGL::Texture* texture;
    std::vector<const InstancedSprite*> users{};
public:
    [[nodiscard]] size_t ReferenceCount() { return users.size(); }
    [[nodiscard]] bool InUseBy(const InstancedSprite* rhs);
    [[nodiscard]] JGL::Texture* GetTexture() const { return texture; }
public:
    void AddUser(const InstancedSprite* user);
    void RemoveUser(const InstancedSprite* user);
public:
    InstancedTexture(JGL::Texture* texture, const InstancedSprite* creator) : texture(texture) { users.push_back(creator); }
    ~InstancedTexture();
};