#pragma once

#include <J3ML/LinearAlgebra/Vector2.hpp>

namespace Engine {
    class Movable;
}

// Movable Object.
class Engine::Movable {
protected:
    // Assuming 0 radians is up.
    float face_angle = 0.0f;
    Vector2 position = {0, 0};
public:
    // Movements independent of the face_angle.
    void MoveX(float speed);
    void MoveY(float speed);
    void Move(float angle_rad, float speed);

    // Movements dependent on face angle.
    void MoveForward(float speed);
    void MoveBackward(float speed);
    void MoveLeft(float speed);
    void MoveRight(float speed);

    void Rotate(float speed);
    void SetRotation(float new_rotation);
public:
    [[nodiscard]] float GetRotation() const;
    [[nodiscard]] Vector2 GetPosition() const;
public:
    explicit Movable(const Vector2& position, float rad_rotation = 0.0f) : position(position), face_angle(rad_rotation) {}
};