#pragma once
#include <Engine/types/entity/Entity.h>

namespace Engine {
    class Renderable;
}

class Engine::Renderable {
protected:
    // Higher numbers are farther to the back.
    unsigned int layer = 0;
public:
    [[nodiscard]] unsigned int GetLayer() const { return layer; }
    void SetLayer(unsigned int new_layer) { layer = new_layer; }
public:
    // *must* be overridden.
    virtual void Render() = 0;
public:
    explicit Renderable(unsigned int layer) :  layer(layer) {}
};