#pragma once

#include <Engine/types/entity/Entity.h>
#include <Engine/types/entity/mixins/Movable.h>
#include <Engine/types/entity/mixins/Renderable.h>

namespace Game {
    class Box;
}

class Game::Box final : public Engine::Entity, public Engine::Renderable, public Engine::Movable {
public:
    void Render() final;
    void Update() final;
public:
    explicit Box(const Vector2& position, unsigned int depth = 0, float rotation = 0.0f) : Renderable(depth), Movable(position, rotation) {}
};