#include <Engine/types/entity/Sprite.h>
#include <JGL/JGL.h>

Engine::Sprite::~Sprite() {
    delete texture;
    delete alpha_mask;
}

void Engine::Sprite::Render() {
    auto* t = GetTexture();
    auto* a = GetAlphaMask();

    if (t && !a)
        return J2D::DrawSprite(t, position, face_angle, origin, scale, base_color);
    if (t && a)
        return J2D::DrawSprite(t, a, position, face_angle, origin, scale, base_color);
}

Texture* Engine::Sprite::GetTexture() {
    return texture;
}

Texture* Engine::Sprite::GetAlphaMask() {
    return alpha_mask;
}

void Engine::Sprite::SetAlphaMask(Texture* new_alpha_mask) {
    alpha_mask = new_alpha_mask;
}
